SystemOrganization addCategory: #Metaprogramacion!
SystemOrganization addCategory: #'Metaprogramacion-fixture'!
SystemOrganization addCategory: #'Metaprogramacion-test'!

Trait named: #TCorredorDeBolsa
	uses: {}
	category: 'Metaprogramacion-fixture'!

!TCorredorDeBolsa methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:46'!
hablar
	self habla: self habla, 'vendo acciones!!'.
	^self habla! !

!TCorredorDeBolsa methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:46'!
laburar
	self habilidades: self habilidades, 'Vender'.
	self energia: self energia - 20.
	^self habilidades! !

Trait named: #TNadador
	uses: {}
	category: 'Metaprogramacion-fixture'!

!TNadador methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:46'!
hablar
	self habla: self habla, 'glup, glup!!'.
	^self habla! !

!TNadador methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:46'!
laburar
	self habilidades: self habilidades, 'Nadar'.
	self energia: self energia - 25.
	^self habilidades! !

TestCase subclass: #AgregadorDeTraitsTest
	instanceVariableNames: 'clasePersona traitNadador traitCorredorDeBolsa'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion-test'!

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
clasePersona
	^ clasePersona! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
clasePersona: anObject
	clasePersona := anObject! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:13'!
resetearFixtureDesdeFile
	MetaUtil recreateCategory: 'Metaprogramacion-fixture'.! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:26'!
setUp
	self resetearFixtureDesdeFile.
	self clasePersona: (Smalltalk at: #Persona).
	self traitNadador: (Smalltalk at: #TNadador).
	self traitCorredorDeBolsa: (Smalltalk at: #TCorredorDeBolsa).! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:14'!
tearDown
	self resetearFixtureDesdeFile! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:39'!
testAgregarDosTraitsConCondicion
	| agregadorDeTraits estrategia claseConteniaTraitNadador claseConteniaTraitCorredorDeBolsa |
	
	estrategia := Condicion new.
	estrategia condicion: #tenesEnergia.
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits estrategia: estrategia.
	
	claseConteniaTraitNadador := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTraitNadador not.
	claseConteniaTraitCorredorDeBolsa := (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).
	self assert: claseConteniaTraitCorredorDeBolsa not.

	agregadorDeTraits agregarTraits: {traitNadador . traitCorredorDeBolsa} aClase: clasePersona.
			
	self assert: (clasePersona traitCompositionIncludes: traitNadador).   
	self assert: (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).   ! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:39'!
testAgregarDosTraitsConFuncion
	| agregadorDeTraits estrategia claseConteniaTraitNadador claseConteniaTraitCorredorDeBolsa |
	
	estrategia := Funcion new.
	estrategia funcion: #concatenar.
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits estrategia: estrategia.
	
	claseConteniaTraitNadador := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTraitNadador not.
	claseConteniaTraitCorredorDeBolsa := (clasePersona traitCompositionIncludes: (Smalltalk at: #TCorredorDeBolsa)).
	self assert: claseConteniaTraitCorredorDeBolsa not.

	agregadorDeTraits agregarTraits: {traitNadador . traitCorredorDeBolsa} aClase: clasePersona.

	self assert: (clasePersona traitCompositionIncludes: traitNadador).
	self assert: (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:52'!
testAgregarDosTraitsEjecutandoTodos
	| agregadorDeTraits estrategia claseConteniaTraitNadador claseConteniaTraitCorredorDeBolsa persona |
	
	estrategia := Todos new.
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits estrategia: estrategia.
	
	claseConteniaTraitNadador := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTraitNadador not.
	claseConteniaTraitCorredorDeBolsa := (clasePersona traitCompositionIncludes: (Smalltalk at: #TCorredorDeBolsa)).
	self assert: claseConteniaTraitCorredorDeBolsa not.

	agregadorDeTraits agregarTraits: {traitNadador . traitCorredorDeBolsa} aClase: clasePersona.

	self assert: (clasePersona traitCompositionIncludes: traitNadador).
	self assert: (clasePersona traitCompositionIncludes: traitCorredorDeBolsa).
! !

!AgregadorDeTraitsTest methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:27'!
testAgregarUnSoloTrait
	| agregadorDeTraits estrategia claseConteniaTrait |
	
	agregadorDeTraits := AgregadorDeTraits new.
	agregadorDeTraits  estrategia: Todos new.
	
	claseConteniaTrait := (clasePersona traitCompositionIncludes: traitNadador).
	self assert: claseConteniaTrait not.
	
	agregadorDeTraits agregarTrait: traitNadador aClase: clasePersona.
		
	self assert: (clasePersona traitCompositionIncludes: traitNadador).! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
traitCorredorDeBolsa
	^ traitCorredorDeBolsa! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:25'!
traitCorredorDeBolsa: anObject
	traitCorredorDeBolsa := anObject! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:26'!
traitNadador
	^ traitNadador! !

!AgregadorDeTraitsTest methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 22:26'!
traitNadador: anObject
	traitNadador := anObject! !

Object subclass: #AgregadorDeTraits
	instanceVariableNames: 'estrategia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!AgregadorDeTraits methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:02'!
agregarTrait: unTrait aClase: unaClase
	"Punto de entrada. Teniendo una instancia de AgregadorDeTraits con una estrategia asignada, con este mtodo se puede agregar un trait a una clase."

	"Agrega el trait a la trait composition de la clase."
	self agregarTraitATraitComposition: unTrait aClase: unaClase.
	
	"Resuelve los posibles conflictos."
	(unTrait methodDict keys) do: [ :unMetodo |
		self resolverConflicto: unMetodo unaClase: unaClase.
		].
	! !

!AgregadorDeTraits methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:03'!
agregarTraitATraitComposition: unTrait aClase: unaClase
	| unaTraitComposition |
	
	unaTraitComposition := (unaClase traitComposition) copyTraitExpression.
	(unaClase traitComposition) + unTrait @{} -{}.
	unaClase applyChangesOfNewTraitCompositionReplacing: unaTraitComposition.
! !

!AgregadorDeTraits methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:59'!
agregarTraits: traits aClase: unaClase
	"Otro punto de entrada. Teniendo una instancia de AgregadorDeTraits con una estrategia asignada, con este mtodo se pueden agregar traits a una clase."
	traits do: [ :trait |
		self agregarTrait: trait aClase: unaClase.
		].
	! !

!AgregadorDeTraits methodsFor: 'accessing' stamp: 'MartinPaoloni 5/6/2013 22:00'!
claseIncluyeTrait: unTrait Clase: unaClase
	^(unaClase traitCompositionIncludes: unTrait)! !

!AgregadorDeTraits methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 19:06'!
estrategia
	^ estrategia! !

!AgregadorDeTraits methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 19:06'!
estrategia: anObject
	estrategia := anObject! !

!AgregadorDeTraits methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:07'!
resolverConflicto: unMetodo unaClase: unaClase
	estrategia resolverMetodo: unMetodo Clase:  unaClase.! !

Object subclass: #MetaUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!MetaUtil class methodsFor: 'as yet unclassified' stamp: 'Demian 9/8/2012 00:29'!
recreateCategory: categoryName
	(SystemOrganization listAtCategoryNamed: categoryName) do: [ :typeName | Smalltalk removeClassNamed: typeName ].
	SystemOrganization removeCategory: categoryName.
	FileStream fileIn: categoryName , '.st'.
	SystemOrganization sortCategories! !

Object subclass: #Persona
	instanceVariableNames: 'energia habla habilidades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion-fixture'!

!Persona methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 22:38'!
concatenar: unaLista
	| resultado |
	resultado := ''.
	unaLista do:[:unElemento |
		resultado := resultado,unElemento.
		].
	^ resultado! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:24'!
energia
	^ energia! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:24'!
energia: anObject
	energia := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:24'!
habilidades
	^ habilidades! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:24'!
habilidades: anObject
	habilidades := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:24'!
habla
	^ habla! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:24'!
habla: anObject
	habla := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 16:30'!
initialize: unaEnergia
	self energia: unaEnergia. "Debe ser un nmero."
	self habilidades: ''.
	self habla: ''.! !

Object subclass: #ResolucionStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

ResolucionStrategy subclass: #Condicion
	instanceVariableNames: 'condicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Condicion methodsFor: 'accessing' stamp: 'MartinPaoloni 5/6/2013 21:56'!
condicion
	^ condicion! !

!Condicion methodsFor: 'accessing' stamp: 'MartinPaoloni 5/6/2013 21:56'!
condicion: anObject
	condicion := anObject! !

!Condicion methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 23:31'!
resolver: metodos Metodo: unMetodo
	| resolucion |
	
	resolucion :=
		unMetodo, ' 
	'.
	metodos do: [ :unAlias |
		resolucion := 
			resolucion,
			'(self ',
			self condicion,
			') ifTrue: [self ',
			(self redefinirAlias: unAlias),
			'] ifFalse: [^self].
'.
		].

	^resolucion.! !

ResolucionStrategy subclass: #Funcion
	instanceVariableNames: 'funcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Funcion methodsFor: 'accessing' stamp: 'MartinPaoloni 5/6/2013 21:52'!
funcion
	^ funcion! !

!Funcion methodsFor: 'accessing' stamp: 'MartinPaoloni 5/6/2013 21:52'!
funcion: anObject
	funcion := anObject! !

!Funcion methodsFor: 'accessing' stamp: 'MartinPaoloni 5/7/2013 23:32'!
resolver: metodos Metodo: unMetodo
	| resolucion |
	
	resolucion := unMetodo, ' 
	'.

	resolucion :=
		resolucion,
		'^(self ',
		(self funcion),
		': {'.
	metodos do: [ :metodo |
		resolucion := (resolucion, '(self ',(self redefinirAlias: metodo),') . ')
		].
	
	resolucion := resolucion allButLast: '. ' size.
	
	resolucion := resolucion, '} )'.
		
	^resolucion.! !

!ResolucionStrategy methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:14'!
agregarAlias: unMetodo Clase: unaClase
	| unaTraitComposition ultimoTrait unaTraitExpresion |
	
	unaTraitComposition := (unaClase traitComposition) copyTraitExpression.
	
	ultimoTrait := (unaClase traitComposition) size.
	unaTraitExpresion := ((unaClase traitComposition) transformations at: ultimoTrait) subject.
	unaTraitExpresion aliases: unaTraitExpresion aliases, ({((unaTraitExpresion subject) name, unMetodo) asSymbol -> unMetodo}). 
	
	unaClase applyChangesOfNewTraitCompositionReplacing: unaTraitComposition.	

	^self! !

!ResolucionStrategy methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:22'!
aliasesDeMetodo: unMetodo Clase: unaClase
	| aliases |
	
	aliases := OrderedCollection new.
	(unaClase traitComposition) transformations do: [ :transformation |
			(transformation aliasesForSelector: unMetodo) do: [ :alias |
				aliases add: alias.
				]
		].
	^aliases.! !

!ResolucionStrategy methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:23'!
redefinirAlias: unMetodo
	| nuevoAlias i parametros |
	
	nuevoAlias := ''.
	i := 1.
	parametros := (unMetodo asString) findString: ':'.
	
	(parametros = 0) 
		ifTrue: [
			^ unMetodo asString.
			]
		ifFalse: [
			((unMetodo asString) subStrings: ':') do: [ :unaParte |
				nuevoAlias :=
					nuevoAlias,
					unaParte,
					': unParametro',
					i asString,
					' '.
				i := i+ 1.
				]
			].

	^ nuevoAlias asString.
	! !

!ResolucionStrategy methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:31'!
resolver: metodos Metodo: unMetodo
	^self subclassResponsibility.! !

!ResolucionStrategy methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:31'!
resolver: metodos Metodo: unMetodo Clase: unaClase
	unaClase compile: (self resolver: metodos Metodo: unMetodo).! !

!ResolucionStrategy methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:34'!
resolverMetodo: unMetodo Clase: unaClase
	| metodos |

	self agregarAlias: unMetodo Clase: unaClase.
	metodos := self aliasesDeMetodo: unMetodo Clase: unaClase.
	self resolver: metodos Metodo: unMetodo Clase: unaClase.
	! !

ResolucionStrategy subclass: #Todos
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metaprogramacion'!

!Todos methodsFor: 'as yet unclassified' stamp: 'MartinPaoloni 5/7/2013 23:32'!
resolver: metodos Metodo: unMetodo
	| resolucion |
	
	resolucion := (self redefinirAlias: unMetodo), ' 
	'.
	metodos do: [ :unAlias |
		resolucion :=
			resolucion,
			'self ',
			(self redefinirAlias: unAlias)
			,'.
	' ].
		
	^resolucion.
		! !
